<template>
    <div class="auth-page">
        <div class="container">
            <div class="row h-100 justify-content-center align-items-center">
                <div class="col-md-6 col-lg-4 form-container rounded">
                    <div class="title text-secondary text-center py-4">Register</div>
                    <form @submit.prevent="onSubmit" class="col-12">
                        <div class="form-group my-4">
                            <label htmlFor="username"> User</label>
                            <input type="text" v-model="username" name="username" class="form-control" v-validate="'required'"
                                   :class="{ 'is-invalid': submitted && errors.has('username') }" />
                            <div v-if="submitted && errors.has('username')" class="invalid-feedback">{{ errors.first('username') }}</div>
                        </div>
                        <div class="form-group my-4">
                            <label htmlFor="email"> Email</label>
                            <input type="text" v-model="email" name="email" class="form-control" v-validate="'required'"
                                   :class="{ 'is-invalid': submitted && errors.has('email') }" />
                            <div v-if="submitted && errors.has('email')" class="invalid-feedback">{{ errors.first('email') }}</div>
                        </div>
                        <div class="form-group my-4">
                            <label htmlFor="password"> Password</label>
                            <input type="password" v-model="password" name="password" class="form-control" v-validate="'required'"
                                   :class="{ 'is-invalid': submitted && errors.has('password') }" />
                            <div v-if="submitted && errors.has('password')" class="invalid-feedback">{{ errors.first('password') }}</div>
                        </div>
                        <div class="form-group my-4">
                            <button class="btn btn-block btn-primary">Register</button>
                            <div class="pt-3">Already Registered?<router-link :to="{ name: 'login' }"><span class="mx-2 font-weight-bold text-dark text-decoration-none">Login</span></router-link>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    import {mapState} from "vuex";
    import {REGISTER} from "@/store/actions.type";

    export default {
        name: "Register",
        data() {
            return {
                username: "",
                email: "",
                password: "",
                submitted: false
            };
        },
        computed: {
            ...mapState({
                errors: state => state.auth.errors
            })
        },
        methods: {
            onSubmit() {
                this.submitted = true;
                this.$validator.validate().then(valid => {
                    if (valid) {
                        this.$store
                            .dispatch(REGISTER, {
                                email: this.email,
                                password: this.password,
                                username: this.username
                            })
                            .then(() => this.$router.push({name: "home"}));
                    }
                });
            }
        }
    };
</script>
<style scoped>
    .auth-page {
        height: 100vh;
        display: flex;
        align-items: center;
        justify-content: center;
    }
    .form-container {
        background-color: #ECEEEF;
    }
    .title{
        font-size: 47px;
    }
</style>